/* Example of okular API usage.
In this example we have three functions. Changer() will render two divs with partial updates
while fullUpdate() function will render the entire screen.
Alternate() function will run fullUpdate() every 10th time, otherwise it will run
changer() function. Alternate() will be run every three seconds (3000 ms).
*/
$( document ).ready(function() {
	//function named changer that implements changing our divs
	function changer() {
		//set our divs to variable for later use
		var compRand = $("#randomNumber");
		var timer = $("#timer");
		//set our random number div to display random number from 10.000 to 1.000.000
		compRand.text((Math.floor(Math.random()*1000000)+10000).toString());
		//set our timer div to display current time
		timer.text(new Date($.now()));
		//declare new array
		list = new Array();
		//add first div (random number) to the array.
		list.push({x: compRand.offset().left, y: compRand.offset().top, //x and y are coordinates of upper left part of div
			width: compRand.outerWidth(), height: compRand.outerHeight(), //set div's height and width
			encoding: 4, dithering: okular.DitheringDefault, //set bit depth and dithering
			rectangleUpdateOptions: 258}); //set our display update options

		//add second div and any other in the same way
		list.push({x: timer.offset().left, y: timer.offset().top,
			width: timer.outerWidth(), height: timer.outerHeight(),
			encoding: 4, dithering: okular.DitheringDefault,
			rectangleUpdateOptions: 258});
		//with RenderRectangles() method we set our divs and display them in desired way
		okular.RenderRectangles(list);
	}

	//function fullUpdate() will render entire screen, body tag being taken as a selector
	function fullUpdate() {
		var screen = $("body");

		list2 = new Array();
		list2.push({x: screen.offset().left, y: screen.offset().top,
			width: screen.outerWidth(), height: screen.outerHeight(),
			encoding: 4, dithering: okular.DitheringDefault,
			rectangleUpdateOptions: 2});

		okular.RenderRectangles(list2);
	}
	//our counter variable is set to 1 (1. iteration)
	var count=1;
	//function alternate() runs changer() in every iteration except in every 10th, fullUpdate() is ran.
	function alternate() {
		//if 10th iteration we update entire screen and set our counter to 1
		console.log(count);
		if(count%11 == 0) {
			count=1;
			fullUpdate();
		}
		//in all other iterations we run our partial update function named changer()
		else {
			count++;
			changer();
		}
	}
	//setInterval() method will run alternate() method every three seconds
	setInterval(alternate,3000);
});
